const Main = imports.ui.main;
const Clutter = imports.gi.Clutter;
const MessageTray = imports.ui.messageTray;
const St = imports.gi.St;
const Lang = imports.lang;
const Panel = imports.ui.main.panel;
const StatusIconDispatcher = imports.ui.statusIconDispatcher;

let removeStatusIcon = [
    'a11y',         // Accessibility
    //'bluetooth'    // Bluetooth
    // 'volume',
    // 'battery',
    // 'keyboard',
    // 'network'
]

let iconConnectId = null;
let oldemit = null;
let iconRemoveId = null;
let idStatusIconAdd = null;
var old_summaryItemTitleWidth;
var old_summary_prop = null;

function _onTrayIconAdded(o,icon) {
    let wmClass = (icon.wm_class || 'unknown').toLowerCase();
    let role = StatusIconDispatcher.STANDARD_TRAY_ICON_IMPLEMENTATIONS[wmClass] || wmClass;
    Main.statusIconDispatcher.oldemit('status-icon-added',icon,role);
    if(role == "glipper") {
        let parentActor = icon.get_parent();
        parentActor.remove_actor(icon);
        let newBin = new St.BoxLayout();
        let newIcon = new St.Icon({icon_name:"edit-cut",
                                 icon_type: St.IconType.FULLCOLOR,
                                style_class: 'system-status-icon'})
        parentActor.add_actor(newBin);
        newBin.add(newIcon);
        icon.reparent(newBin);
        icon.set_position(0,0);
        icon.opacity = 0;
    }
}

function _onTrayIconRemoved(o,icon) {
    Main.statusIconDispatcher.oldemit('status-icon-removed',icon);
}

function new_add(source) {
    this.old_add(source);

    if(Main.messageTray._summaryItemTitleWidth != 0)
    {
        old_summaryItemTitleWidth = Main.messageTray._summaryItemTitleWidth;
        Main.messageTray._summaryItemTitleWidth = 0;
    }

    let items = Main.messageTray._summary.get_children();
    for(i in items)
    {
        let child = items[i].get_child()

        if(child.oldSetSize == undefined)
        {
            child.oldSetSize = child.setTitleWidth;
            child.setTitleWidth = function() {}
            child.old_text = child.get_children()[1].get_child().get_text();            child.get_children()[1].get_child().set_text('');
        }
    }
}

function showTray() {
    this.actor.y = 0;
    this.actor.width = 0;
    this._trayState = MessageTray.State.SHOWN;
}

function hideTray() {
    this.actor.y = 0;
    this.actor.width = 0;
    this._trayState = MessageTray.State.HIDDEN;
}

function _updateShowingNotification() {
    this._notificationBin.y = 0; //-this._notificationBin.height;
    let monitor = Main.layoutManager.bottomMonitor;

    this._notificationBin.width = this._notificationBin.get_child().width;
    this._notificationBin.x = monitor.x + monitor.width;
    this._notificationBin.set_anchor_point_from_gravity(Clutter.Gravity.NORTH_EAST);
    MessageTray.MessageTray.prototype._updateShowingNotification.call(this);
}

function _hideNotification() {
    MessageTray.MessageTray.prototype._hideNotification.call(this);
    this._tween(this._notificationBin, '_notificationState', MessageTray.State.HIDDEN,
                { y: 0,
                  opacity: 0,
                  time: MessageTray.ANIMATION_TIME*3,
                  transition: 'easeOutQuad',
                  onComplete: this._hideNotificationCompleted,
                  onCompleteScope: this
                });
}

function _onNotificationExpanded() {
    let expandedY = 0;//this.actor.height - this._notificationBin.height;

    // Don't animate the notification to its new position if it has shrunk:
    // there will be a very visible "gap" that breaks the illusion.

    if (this._notificationBin.y < expandedY)
        this._notificationBin.y = expandedY;
    else if (this._notification.y != expandedY) {
        this._notificationBin.y = 0;
        this._tween(this._notificationBin, '_notificationState', MessageTray.State.SHOWN,
                    { y: expandedY,
                      time: MessageTray.ANIMATION_TIME,
                      transition: 'easeOutQuad'
                    });
    }
}

function _updateBoxes() {
    try {
        this.panelBox.set_position(this.primaryMonitor.x, this.primaryMonitor.y);
        this.panelBox.set_size(this.primaryMonitor.width, -1);

        this.keyboardBox.set_position(this.bottomMonitor.x,
                                      this.bottomMonitor.y + this.bottomMonitor.height);
        this.keyboardBox.set_size(this.bottomMonitor.width, -1);

        this.trayBox.set_position(0,Main.panel.actor.height);
        this.trayBox.remove_clip();
    } catch (e) {
    }
}

function init() {
}

function enable() {
    StatusIconDispatcher.STANDARD_TRAY_ICON_IMPLEMENTATIONS['blueman-applet'] = 'bluetooth';
    old_summary_prop = {}
    old_summary_prop.parent_actor = Main.messageTray._summary.get_parent();
    old_summary_prop.parent_actor.remove_actor(Main.messageTray._summary);
    old_summary_prop.height = Main.messageTray._summary.height;
    Main.messageTray._summary.height = Main.panel.actor.height;
    Main.panel._rightBox.insert_actor(Main.messageTray._summary,0);
    idStatusIconAdd = Main.statusIconDispatcher.connect('status-icon-added',
                                                      Lang.bind(Main.messageTray._summary,function() {
        this.lower_bottom();
    }));

    old_summary_prop._arrowSide = Main.messageTray._summaryBoxPointer._arrowSide;
    Main.messageTray._summaryBoxPointer._arrowSide = St.Side.TOP;
    old_summary_prop._showTray = Main.messageTray._showTray;
    Main.messageTray._showTray = Lang.bind(Main.messageTray,showTray);
    old_summary_prop._hideTray = Main.messageTray._hideTray;
    Main.messageTray._hideTray = Lang.bind(Main.messageTray,hideTray);
    old_summary_prop._updateShowingNotification = Main.messageTray._updateShowingNotification;
    Main.messageTray._updateShowingNotification = Lang.bind(Main.messageTray,_updateShowingNotification);
    old_summary_prop._hideNotification = Main.messageTray._hideNotification;
    Main.messageTray._hideNotification = Lang.bind(Main.messageTray,_hideNotification);
    old_summary_prop._onNotificationExpanded = Main.messageTray._onNotificationExpanded;
    Main.messageTray._onNotificationExpanded = Lang.bind(Main.messageTray,_onNotificationExpanded);
    old_summary_prop._updateBoxes = Main.layoutManager._updateBoxes;
    Main.layoutManager._updateBoxes = Lang.bind(Main.layoutManager,_updateBoxes);
    Main.layoutManager._updateBoxes();
    Main.messageTray._showTray();
    old_summary_prop.idFocusGrabber = Main.messageTray._focusGrabber.connect('focus-ungrabbed',
                                      Lang.bind(Main.messageTray, function() {
        this._summaryState = MessageTray.State.HIDDEN;
    }));

    Main.statusIconDispatcher.oldemit = Main.statusIconDispatcher.emit;
    Main.statusIconDispatcher.emit = function() {};
    iconConnectId = Main.statusIconDispatcher._traymanager.connect('tray-icon-added',
        Lang.bind(Main.statusIconDispatcher,_onTrayIconAdded));
    iconRemoveId = Main.statusIconDispatcher._traymanager.connect('tray-icon-removed',
        Lang.bind(Main.statusIconDispatcher,_onTrayIconRemoved));
    for(let e=0;e < removeStatusIcon.length;e++) {
        Panel._statusArea[removeStatusIcon[e]].actor.hide();
    }

    old_summaryItemTitleWidth = Main.messageTray._summaryItemTitleWidth;
    Main.messageTray._summaryItemTitleWidth = 0;

    let items = Main.messageTray._summary.get_children();
    for(i in items)
    {
        let child = items[i].get_child()

        child.old_text = child.get_children()[1].get_child().get_text();
        child.get_children()[1].get_child().set_text('');
        child.oldSetSize = child.setTitleWidth;
        child.setTitleWidth = function() {}
    }

    Main.messageTray.old_add = Main.messageTray.add;
    Main.messageTray.add = new_add;

    Main.messageTray._updateState();
}

function disable() {
    StatusIconDispatcher.STANDARD_TRAY_ICON_IMPLEMENTATIONS['blueman-applet']= undefined;
    Main.messageTray._summary.height = old_summary_prop.height;
    Main.panel._rightBox.remove_actor(Main.messageTray._summary);
    old_summary_prop.parent_actor.add_actor(Main.messageTray._summary);

    Main.statusIconDispatcher.disconnect(idStatusIconAdd);
    Main.messageTray._summaryBoxPointer._arrowSide = old_summary_prop._arrowSide;
    Main.messageTray._showTray = old_summary_prop._showTray;
    Main.messageTray._hideTray = old_summary_prop._hideTray;
    Main.messageTray._updateShowingNotification = old_summary_prop._updateShowingNotification;
    Main.messageTray._hideNotification = old_summary_prop._hideNotification;
    Main.messageTray._onNotificationExpanded = old_summary_prop._onNotificationExpanded;
    Main.layoutManager._updateBoxes = old_summary_prop._updateBoxes;
    Main.layoutManager._updateBoxes();
    Main.messageTray._showTray();
    Main.messageTray._focusGrabber.disconnect(old_summary_prop.idFocusGrabber);

    Main.statusIconDispatcher._traymanager.disconnect(iconConnectId);
    Main.statusIconDispatcher._traymanager.disconnect(iconRemoveId);
    Main.statusIconDispatcher.emit = Main.statusIconDispatcher.oldemit;

    for(let e=0;e < removeStatusIcon.length;e++) {
        Panel._statusArea[removeStatusIcon[e]].actor.show();
    }
    Main.messageTray.add = Main.messageTray.old_add;

    let items = Main.messageTray._summary.get_children();
    for(i in items) {
        let child = items[i].get_child();

        child.get_children()[1].get_child().set_text(child.old_text);
        child.old_text = undefined;
        child.setTitleWidth = child.oldSetSize;
        child.oldSetSize = undefined;
    }
    Main.messageTray._summaryItemTitleWidth = old_summaryItemTitleWidth;
}
